;def.inc
;********************************************************************
;	 
;********************************************************************

#ifdef __DEBUG
        CONFIG	PWRT    = OFF
        CONFIG  BOREN   = OFF
        CONFIG  WDTEN   = OFF
        CONFIG  STVREN  = OFF
#else
        CONFIG	PWRT    = ON
        CONFIG  BOREN   = ON
        CONFIG  WDTEN   = ON
        CONFIG  STVREN  = ON
#endif  
        CONFIG  FOSC    = HSPLL
        CONFIG	FCMEN   = OFF
        CONFIG	IESO    = OFF
        CONFIG  BORV    = 22
        CONFIG  WDTPS   = 128
        CONFIG	CCP2MX  = PORTC
        CONFIG	PBADEN  = OFF
        CONFIG	LPT1OSC = OFF
        CONFIG  HFOFST  = OFF
	CONFIG	MCLRE   = ON
        CONFIG  LVP     = OFF
	CONFIG	XINST   = OFF

#define MODE_I2C
;#define MODE_SPI

;********************************************************************
;	  
;********************************************************************

#define	pin_H_SYNC	LATC, LATC0	;[32]  
#define	pin_V_SYNC	LATC, LATC1	;[35]  
#define	pin_F_1HZ	LATC, LATC2	;[36]  1   FLASH

#define	lat_COLOR	LATD		; 

;********************************************************************
;	 
;********************************************************************

TRISA_CONST	equ	0x20	;RA5  not_SS
TRISC_CONST	equ	0x18	; USART, SPI, I2C
T2CON_CONST	equ	0x0C	;post = 2, prs = 1, TMR2ON = 1 
T1CON_CONST	equ	0x31	;prs = 8, TMR1ON = 1
T0CON_CONST	equ	0x86	;T0ON, 16 bit, prs = 128, T = 520 ms
PR2_CONST	equ	.253	;(253+1)*2=508*1/16=31.75 us

X_SIZE          equ     .51     ; , 
Y_SIZE          equ     .30     ; , 

ADDR_I2C	equ	0x76	;    I2C

;********************************************************************
;	  RAM
;	* -   
;********************************************************************
        
        CBLOCK  0x00

	;----------------------------------------
	;  
	;----------------------------------------
        FLAGS		;*    
        CountX		;     
        CountY
        flash_counter	;*    
	temp, calc
	
	;----------------------------------------
	;  SPI
	;----------------------------------------
        CMD_Temp	;*    

	;----------------------------------------
	; VGA
	;----------------------------------------
        CurPos		;*     
        CurLineL	;*      0...15
        CurLineH	;*      0...YSIZE-1
        TMR2_Temp	;*      

	;----------------------------------------
	;  
	;----------------------------------------
        XPos		;      X 
        YPos		;      Y 
        CurColor	;      
        CursorSize	;*     
        cursor_temp	;*     
	FSR2_temp:2	;*     FSR2
	
	;----------------------------------------
	; 
	;----------------------------------------
	WinColor	;      
	WinCounter	;      
	CurWin		;      
	
	; 
	WinX		;        X
	WinY		;        Y
	WinWidth	;       
	WinHeigh	;       
	PrevXPos	;    XPos  
	PrevYPos	;    YPos  
	PrevColor	;    CurColor  
	PrevCursor	;    CursorSize  

	FreeMem:2	;      
	
	;----------------------------------------
	; 
	;----------------------------------------
        TextData: Y_SIZE*X_SIZE*2
        
        ;----------------------------------------
        ;  
        ; 
        ;  -8 WinX	  ;   
        ;  -7 WinY	  ;   
        ;  -6 WinWidth	  ; 
        ;  -5 WinHeigh	  ; 
        ;  -4 PrevXPos	  ; 
        ;  -3 PrevYPos	  ; 
        ;  -2 PrevColor	  ;
        ;  -1 PrevCursor  ; 
        ;   0 WinData	  ;  
        ;----------------------------------------
        WinData
        
        ENDC

;**************************************;
;	                  ;
;**************************************;
                                       ;
	;              ;
#define bByteReceived   FLAGS, 0       ;
;--------------------------------------;

;********************************************************************
