;interrupt.asm
;********************************************************************
;	 
;********************************************************************


;**************************************;
;	            ;
;    8  ;
;**************************************;
                                       ;
OUT_SYMBOL   MACRO                     ;
        movf    POSTINC2, w            ; 1       
        movff   POSTINC2, TBLPTRL      ; 2,3    
        tblrd*                         ; 4,5     
        movff   TABLAT, TXREG          ; 6,7     
        movwf   lat_COLOR              ; 8 (*)  
        ENDM                           ;
                                       ;
;--------------------------------------;


;**************************************;
;       w <-> f   ;
;**************************************;
SWAPWF MACRO REG                       ;
	xorwf	REG, f                 ;
	xorwf	REG, w                 ;
	xorwf	REG, f                 ;
    ENDM                               ;
;--------------------------------------;


;********************************************************************
;							
;       31,75  (508 )	      31,77 (-0.06%)
;  :
;      3,75  (60 )               3,77 (-0.5%)
;  +
;            28,00  (448 )
;  :
;        1,50  (24 )                1,89 (-20%)
;  +
;     25,50  (408  = 51  8)    25,17 (+1.3%)
;  +
;       1,00  (16 )               0,94 (+6.4%)
;
;        3.75                25.5           1     1.5
;|||||__     ____||||||||||||||||||||||||||__     ____||||||||||||||
;       |___|                                |___|
;
;********************************************************************

	ORG	0x0008
	
	movf	FSR2L, w		; FSR2
	SWAPWF	FSR2_temp
	movwf	FSR2L
	movf	FSR2H, w
	SWAPWF	FSR2_temp+1
	movwf	FSR2H
        
        bcf     PIR1, TMR2IF            ;-1

        bsf     pin_H_SYNC              ; 0
        btfss   CurPos, 5               ; 1        32 
        bra     blank_line              ; 2 (3)  32 -  
        
;********************************************************************
;	 
;********************************************************************

        ;----------------------------------------
        ;     
        ;----------------------------------------
	nop				;3       - 
	nop				;4
	nop				;5
	nop				;6
	nop				;7
	nop				;8
        movf    PREINC1, w              ;9	  
        movwf   cursor_temp             ;10       
        
        movf    CurLineL, w             ;11      ?
        cpfsgt  CursorSize              ;12, (13)      
        clrf    INDF1                   ;13      -   0

        ;----------------------------------------
        ;  USART
        ;----------------------------------------
        bsf     RCSTA, SPEN             ;14      USART
        clrf    TXREG                   ;15(*)       
                                        ;          9, 17, 25, ... (1+i*8)
        incf    CurLineL, f     	;16	  

        ;----------------------------------------
        ;    51 
        ;----------------------------------------

        OUT_SYMBOL	;1
        OUT_SYMBOL	;2
        OUT_SYMBOL	;3
        OUT_SYMBOL	;4
        OUT_SYMBOL	;5
        OUT_SYMBOL	;6
        OUT_SYMBOL	;7
        OUT_SYMBOL	;8
        OUT_SYMBOL	;9
        OUT_SYMBOL	;10
        
        OUT_SYMBOL	;1
        OUT_SYMBOL	;2
        OUT_SYMBOL	;3
        OUT_SYMBOL	;4
        OUT_SYMBOL	;5
        OUT_SYMBOL	;6
        OUT_SYMBOL	;7
        OUT_SYMBOL	;8
        OUT_SYMBOL	;9
        OUT_SYMBOL	;10
        
        OUT_SYMBOL	;1
        OUT_SYMBOL	;2
        OUT_SYMBOL	;3
        OUT_SYMBOL	;4
        OUT_SYMBOL	;5
        OUT_SYMBOL	;6
        OUT_SYMBOL	;7
        OUT_SYMBOL	;8
        OUT_SYMBOL	;9
        OUT_SYMBOL	;10
        
        OUT_SYMBOL	;1
        OUT_SYMBOL	;2
        OUT_SYMBOL	;3
        OUT_SYMBOL	;4
        OUT_SYMBOL	;5
        OUT_SYMBOL	;6
        OUT_SYMBOL	;7
        OUT_SYMBOL	;8
        OUT_SYMBOL	;9
        OUT_SYMBOL	;10
        
        OUT_SYMBOL	;1
        OUT_SYMBOL	;2
        OUT_SYMBOL	;3
        OUT_SYMBOL	;4
        OUT_SYMBOL	;5
        OUT_SYMBOL	;6
        OUT_SYMBOL	;7
        OUT_SYMBOL	;8
        OUT_SYMBOL	;9
        OUT_SYMBOL	;10

        OUT_SYMBOL	;1
        
        ;----------------------------------------
        ; SPEN     7 
        ;----------------------------------------
        bcf     CurLineL, 6             ;425         
        movff   cursor_temp, POSTDEC1   ;426, 427   
        				;           

        ;----------------------------------------
        ;   FSR2:
        ; -    - FSR2  
        ;        
        ; -    - FSR2  
        ;    
        ;----------------------------------------
        btfsc   CurLineL, 4             ;428
        bra     skip_correct_fsr2       ;429 (430)

correct_fsr2:                           ;  , FSR2 -= X_SIZE*2
        movlw   X_SIZE*2                ;430
        bcf     RCSTA, SPEN             ;431 (*)
        subwf   fsr2l, f                ;432
        clrf    lat_COLOR               ;433
        movlw   0                       ;434
        subwfb  fsr2h, f                ;435
        incf    TBLPTRH, f              ;436
        bra     I_T_EXIT                ;437, 438

skip_correct_fsr2:                      ;  , TBLPTR -    
        bcf     RCSTA, SPEN             ;431 (*)
        incf    CurLineH, f             ;432  
        clrf    lat_COLOR               ;433
        movlw   Y_SIZE                  ;434
        cpfslt  CurLineH                ;435
        rlncf   CurPos, f               ;436
        movlw   high(FONT_TABLE)        ;437
        movwf   TBLPTRH                 ;438

	;----------------------------------------
	;  
	;----------------------------------------
I_T_EXIT:
        movf    TMR0L, w                ;439   TMR0H ( TMR0L)
        bcf     CurLineL, 4             ;440     16 
        btfsc   TMR0H, 7                ;441 (442)
        bsf     CurLineL, 6             ;442   6 -  
                                        ;        =1 -  
                                        ;        =0 -  
	nop				;443
	
	;----------------------------------------
	;	 
	;----------------------------------------
        btfss   SSPSTAT, BF             ;444 (445)
        bra     NO_SPI_DATA             ;445, 446

        movff   SSPBUF, CMD_Temp        ;446, 447   - 
        bcf     pin_H_SYNC              ;448(*)  
        
        bsf     bByteReceived           ;  
#ifdef MODE_I2C
        bcf	SSPCON1, CKP
#endif
	goto	store_fsr2
        dw      0xFFFF
        
;********************************************************************
;	 
;********************************************************************
blank_line:

        incf    CurPos, f               ; 4	  
        
        ;  
        movlw   -0x4D
        addwf   CurPos, w
        btfss   status, c
        bra     not_v_sync              ;1, 2
        
        ; 
v_sync:
        bcf     pin_V_SYNC              ;2    
        bnz     i_reset_curpos          ;3 (4)
        lfsr    2, TextData             ;4, 5
        clrf    CurLineH                ;6     0...Y_SIZE
        clrf    CurLineL                ;7      0...15
        movlw   high(FONT_TABLE)        ;8
        movwf   TBLPTRH                 ;9
        bra     I_V_EXIT                ;10,11
i_reset_curpos:
        nop                             ;5
        nop                             ;6
        movlw   .2                      ;7
        movwf   CurPos                  ;8
        nop                             ;9
        bra     i_v_exit                ;10, 11
not_v_sync:     
        bsf     pin_V_SYNC              ;11    
        
I_V_EXIT:
	;----------------------------------------
	;  1 Hz  FLASH
	;Ftmr1 = 30,5 Hz / 32 ~ 1 Hz
	;----------------------------------------
	btfss	PIR1, TMR1IF		;12
	goto	check_system		;13, 14
	bcf	PIR1, TMR1IF		;14
	incf	flash_counter, f	;16
	btfss	flash_counter, 4	;17 (18)
	bcf	pin_F_1HZ		;18
	btfsc	flash_counter, 4	;19 (20)
	bsf	pin_F_1HZ		;20
	
        ;----------------------------------------
        ; 
        ;----------------------------------------
check_system:
        ;----------------------------------------
        ; PCLATH
        ;----------------------------------------
        movlw   high(CMD_JUMP_TABLE)
        xorwf   PCLATH, w
        btfss   STATUS, z
        RESET   

        ;----------------------------------------
        ; 
        ;----------------------------------------
        movlw   TRISA_CONST
        xorwf   TRISA, w
        btfss   status, z
        RESET
        
        movlw   TRISC_CONST
        xorwf   TRISC, w
        btfss   status, z
        RESET
        
        movlw   T2CON_CONST
        xorwf   T2CON, w
        btfss   status, z
        RESET

        movlw   T1CON_CONST
        xorwf   T1CON, w
        btfss   status, z
        RESET

        movlw   T0CON_CONST
        xorwf   T0CON, w
        btfss   status, z
        RESET

        movlw   PR2_CONST
        xorwf   PR2, w
        btfss   status, z
        RESET

        ;----------------------------------------
        ;  FSR1  FSR2 
        ;----------------------------------------
test_fsr1_less:        
        tstfsz  FSR1H
        bra     test_fsr1_greater
        movlw   low(TextData)
        cpfslt  FSR1L
        bra     test_fsr1_OK
        RESET
test_fsr1_greater:
        movlw   high(WinData)
        cpfsgt  FSR1H
        bra     $+4
        RESET
        cpfseq  FSR1H
        bra     test_fsr1_OK
        movlw   low(WinData)
        cpfsgt  FSR1L
        bra     test_fsr1_OK
        RESET
test_fsr1_OK:

test_fsr2_less:        
        tstfsz  FSR2H
        bra     test_fsr2_greater
        movlw   low(TextData)
        cpfslt  FSR2L
        bra     test_fsr2_OK
        RESET
test_fsr2_greater:
        movlw   high(WinData)
        cpfsgt  FSR2H
        bra     $+4
        RESET
        cpfseq  FSR2H
        bra     test_fsr2_OK
        movlw   low(WinData)
        cpfsgt  FSR2L
        bra     test_fsr2_OK
        RESET

        ;----------------------------------------
        ; WDT,   
        ;----------------------------------------
test_fsr2_OK:
        CLRWDT

        ;----------------------------------------
        ;A   
        ;----------------------------------------
        movf    TMR2, w
        sublw   (.274 - .160 - .5 - .6)
        movwf   TMR2_Temp
        rrcf    WREG, w
        rrcf    WREG, w
        
        andlw   0x3F
        addlw	.160/4
correction_loop:
        nop
        addlw   -1
        bnz     correction_loop
        nop

        ; min: 6 cycles, max: 9 cycles
        btfsc   TMR2_Temp, 0
        bra     $+2
        btfsc   TMR2_Temp, 1
        bra     $+2
        btfsc   TMR2_Temp, 1
	bra     $+2
	nop
	nop
	
	;   
	; 274 (264   FSR) 
	; -    444 
	movlw	.45			;264 (274)
cor_loop2:
	nop
        addlw   -1
        bnz     cor_loop2
	
	;----------------------------------------
	;  
	;----------------------------------------
        btfss   SSPSTAT, BF             ;444 (445)
        bra     NO_SPI_DATA             ;445, 446

        movff   SSPBUF, CMD_Temp        ;446, 447
        bcf     pin_H_SYNC              ;448(*)	 .
        
        bsf     bByteReceived		;  
#ifdef MODE_I2C
        bcf	SSPCON1, CKP
#endif
	goto	store_fsr2
        
        ;----------------------------------------
        ;  
        ;----------------------------------------
NO_SPI_DATA:
	nop				;447
        bcf     pin_H_SYNC              ;448(*)	 
        
store_fsr2:
	movf	FSR2L, w		; FSR2
	SWAPWF	FSR2_temp
	movwf	FSR2L
	movf	FSR2H, w
	SWAPWF	FSR2_temp+1
	movwf	FSR2H
	
        retfie  fast

;********************************************************************
