;subs.asm
;********************************************************************
;	 
;********************************************************************

;********************************************************************
;	 
;********************************************************************

WORK_NEW_COMMAND:
     	rlncf   CMD_Temp, w
        addwf   PCL, f
        
        ; 
CMD_JUMP_TABLE:
        bra     WORK_NOP		;00  
        
        ;   
        bra     WORK_SET_X		;01 x : 0...X_SIZE-1
        bra     WORK_SET_Y		;02 y : 0...Y_SIZE-1
        bra     WORK_SET_CURSOR		;03  
        bra     WORK_SET_COLOR		;04  
        bra     WORK_SET_SYMBOL_COLOR	;05     
        
        ; 
        bra	WORK_WIN_CREATE		;06  
        bra	WORK_WIN_DELETE		;07  
        bra	WORK_ANSI_BS		;08 
        bra	WORK_ANSI_HTAB		;09   8 
        bra	WORK_ANSI_LF		;0A  
        bra	WORK_ANSI_VTAB		;0B  
        bra	WORK_ANSI_FF		;0C  
        bra	WORK_ANSI_CR		;0D  
	bra	WORK_STRING_INVERT	;0E   
	
	;    
	bra	WORK_SET_WIN_X		;0F X    
	bra	WORK_SET_WIN_Y		;10 Y    
	bra	WORK_SET_WIN_WIDTH	;11  
	bra	WORK_SET_WIN_HEIGH	;12  
	bra	WORK_SET_WIN_COLOR	;13  
	bra	WORK_SET_CURWIN		;14   
	
        ; 
        bra     WORK_SEND_X_SIZE	;15  , 
        bra     WORK_SEND_Y_SIZE	;16  , 
        bra     WORK_SEND_SYMBOL	;17    
        bra     WORK_SEND_X		;18   x
        bra     WORK_SEND_Y		;19   y
        bra     WORK_SEND_CURSOR	;1A  
        bra     WORK_SEND_COLOR		;1B  
        bra     WORK_SEND_SYMBOL_COLOR	;1C    
	bra	WORK_SEND_WIN		;1D    0 - 
	bra	WORK_SEND_FREEMEM	;1E   /2

	; 
        bra     WORK_SEND_CHECK		;1F   

;********************************************************************
;  00   
;********************************************************************

WORK_NOP:
	return

;********************************************************************
;  01    X 
;        XPos    FSR1
;********************************************************************

WORK_SET_X:
        ;----------------------------------------
        ;  FSR0 -   
        ; FSR0 = TextData + (YPos*X_SIZE)*2
        ;----------------------------------------
        lfsr    0, TextData

        movf    YPos, w
        mullw   X_SIZE * 2
        
        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f

        ;----------------------------------------
        ;  
        ;----------------------------------------
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

	;----------------------------------------
	;   
	;  -   0
	;----------------------------------------
        movff   CMD_Temp, XPos
        movlw   X_SIZE
        cpfslt  XPos
        clrf	XPos

        ;----------------------------------------
        ; FSR0 = FSR0 + 2*XPos
        ;----------------------------------------
        rlncf   XPos, w
        
        addwf   FSR0L, f
        btfsc   STATUS, C
        incf    FSR0H, f

        ;----------------------------------------
        ; FSR1 = FSR0
        ;----------------------------------------
        lfsr    1, TextData + .256      ; To prevent data loss during assignment
                                        ; Value of indf1 is modified by ISR to 
                                        ; emulate blinking cursor. So we should be
                                        ; sure that fsr1 does not point outside 
                                        ; video memory
        movff   fsr0l, fsr1l
        movff   fsr0h, fsr1h

        return

;********************************************************************
;  02    Y 
;        YPos    FSR1.
;********************************************************************

WORK_SET_Y:
        ;----------------------------------------
        ;  FSR0 -    XPos
        ; FSR0 = TextData + 2*XPos
        ;----------------------------------------
        lfsr    0, TextData
        rlncf   XPos, w
        addwf   FSR0L, f
        btfsc   STATUS, C
        incf    FSR0H, f

        ;----------------------------------------
        ;  
        ;----------------------------------------
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

	;----------------------------------------
	;   
	;  -   0
	;----------------------------------------
        movff   CMD_Temp, YPos
        movlw   Y_SIZE
        cpfslt  YPos
        clrf	YPos

        ;----------------------------------------
        ; FSR0 = FSR0 + YPos*X_SIZE*2
        ;----------------------------------------
        movf    YPos, w
        mullw   X_SIZE * 2

        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f
        
        ;----------------------------------------
        ; FSR1 = FSR0
        ;----------------------------------------
        lfsr    1, TextData + .256      ; To prevent data loss during assignment
                                        ; Value of indf1 is modified by ISR to 
                                        ; emulate blinking cursor. So we should be
                                        ; sure that fsr1 does not point outside 
                                        ; video memory
        movff   fsr0l, fsr1l
        movff   fsr0h, fsr1h

        return

;********************************************************************
;  03    
;      0 - , 15 -  
;********************************************************************

WORK_SET_CURSOR:

        ;----------------------------------------
        ;  
        ;----------------------------------------
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

        ;----------------------------------------
        ;   
        ;   (=0x10 - )
        ;----------------------------------------
        movf    CMD_Temp, w
        andlw   0xF
        sublw   0x10
        iorlw   0x40
        movwf   CursorSize
        return

;********************************************************************
;  04   
;      bit7 - FLASH (1 - )
;      bit6 -   (1-)
;
;      bit5 -  
;      bit4 -  
;      bit3 -  
;
;      bit2 -  
;      bit1 -  
;      bit0 -  
;********************************************************************

WORK_SET_COLOR:
        ;----------------------------------------
        ;  
        ;----------------------------------------
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

        ;----------------------------------------
        ;   
        ;----------------------------------------
        movff    CMD_Temp, CurColor
       	return

;********************************************************************
;  05     
;********************************************************************

WORK_SET_SYMBOL_COLOR:
        ;----------------------------------------
        ;  
        ;----------------------------------------
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

        ;----------------------------------------
        ;  
        ;----------------------------------------
        movf	CMD_Temp, w
 	movwf	INDF1
        return

;********************************************************************
;  06   
;         , ,
;            
;          ,
;         ,  
;          5 ms    400 
;********************************************************************

WORK_WIN_CREATE:

	;   
	call	get_free_mem
	
	;   
	movf	WinCounter, w
	call	get_win_pointer
	
	;  
	movf	WinX, w
	addwf	WinWidth, w
	movwf	temp
	movlw	X_SIZE+1
	cpfslt	temp
	return
	
	;  
	movf	WinY, w
	addwf	WinHeigh, w
	movwf	temp
	movlw	Y_SIZE+1
	cpfslt	temp
	return
	
	;  
	movf	WinWidth, w
	mulwf	WinHeigh

	;if PRODH <= FreeMem+1
        incf	FreeMem+1, w
        cpfslt	PRODH
        return
        
        ;if PRODH = FreeMem+1
        movf	FreeMem+1, w
        cpfseq	PRODH
      	goto	store_area
      	
      	;if PRODL <= FreeMem
	incf	FreeMem, w
	cpfslt	PRODL
	return

store_area:
	; 
	movff	XPos, PrevXPos
	movff	YPos, PrevYPos
	movff	CurColor, PrevColor
	movff	CursorSize, PrevCursor

	;  .
	; FSR0 -   
	call	put_win_pointer
	
	;   
	clrf	CountY
	clrf	CountX

store_line:
	;    FSR2
	lfsr    2, TextData
	
	movf    WinY, w
	addwf	CountY, w
        mullw   X_SIZE * 2

        movf    PRODL, w
        addwf   FSR2L, f
        movf    PRODH, w
        addwfc  FSR2H, f
	
	movf	WinX, w
	mullw	2
	
        movf    PRODL, w
        addwf   FSR2L, f
        movf    PRODH, w
        addwfc  FSR2H, f
        
next_x:
	;   
	;    
	;   
	movff	INDF2, POSTINC0
	movff	WinColor, POSTINC2
        
        ;   
        ;    
        ; 
        movff	INDF2, POSTINC0
        movlw	' '
        movwf	POSTINC2
        
        ; 
        incf	CountX, f
        movf	WinWidth, w	;if CountX = WinWidth
        cpfseq	CountX
        goto	next_x
        
        ; Y
next_y:
	clrf	CountX
	incf	CountY, f
	movf	WinHeigh, w
	cpfseq	CountY
	goto	store_line
	
set_coursor:
        ; 
        movlw   0x10
        iorlw   0x40
        movwf   CursorSize
        
        ;   
        movff	WinColor, CurColor
        
        ;    
        movff	WinX, XPos
        movff	WinY, YPos
        
        ;----------------------------------------
        ;  FSR0 -   
        ; FSR0 = TextData + (YPos*X_SIZE)*2
        ;----------------------------------------
        lfsr    0, TextData

        movf    YPos, w
        mullw   X_SIZE * 2
        
        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f

        ;----------------------------------------
        ; FSR0 = FSR0 + 2*XPos
        ;----------------------------------------
        rlncf   XPos, w
        
        addwf   FSR0L, f
        btfsc   STATUS, C
        incf    FSR0H, f

        ;----------------------------------------
        ; FSR1 = FSR0
        ;----------------------------------------
        lfsr    1, TextData + .256      ; To prevent data loss during assignment
                                        ; Value of indf1 is modified by ISR to 
                                        ; emulate blinking cursor. So we should be
                                        ; sure that fsr1 does not point outside 
                                        ; video memory
        movff   fsr0l, fsr1l
        movff   fsr0h, fsr1h

	;  
	incf	WinCounter, f
	movff	WinCounter, CurWin
	
	return

;********************************************************************
;  07   
;           
;          4 ms    400 
;********************************************************************

WORK_WIN_DELETE:
	;  - 
	movf	WinCounter, w
	btfsc	STATUS, Z
	return

	;   
	; FSR0 -    
	decf	WinCounter, w
	call	get_win_pointer

	; 
	clrf	CountX
	clrf	CountY

restore_line:
	;    FSR2
	lfsr	2, TextData
	
	movf	WinY, w
	addwf	CountY, w
	mullw	X_SIZE*2
	
	movf	PRODL, w
	addwf	FSR2L, f
	movf	PRODH, w
	addwfc	FSR2H, f
	
	movf	WinX, w
	mullw	2
	
	movf	PRODL, w
	addwf	FSR2L, f
	movf	PRODH, w
	addwfc	FSR2H, f

next_x_area:
        
	;      
	;   
	movff	POSTINC0, POSTINC2
	movff	POSTINC0, POSTINC2
	
	; X
	incf	CountX, f
	movf	WinWidth, w
	cpfseq	CountX
	goto	next_x_area
	
	; Y
	clrf	CountX
	incf	CountY, f
	movf	WinHeigh, w
	cpfseq	CountY
	goto	restore_line
	
	; ,    
restore_coursor:
	movff	PrevCursor, CursorSize
	movff	PrevColor, CurColor
	movff	PrevYPos, YPos
	movff	PrevXPos, XPos
	
        ;----------------------------------------
        ;  FSR0 -   
        ; FSR0 = TextData + (YPos*X_SIZE)*2
        ;----------------------------------------
        lfsr    0, TextData

        movf    YPos, w
        mullw   X_SIZE * 2
        
        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f

        ;----------------------------------------
        ; FSR0 = FSR0 + 2*XPos
        ;----------------------------------------
        rlncf   XPos, w
        
        addwf   FSR0L, f
        btfsc   STATUS, C
        incf    FSR0H, f

        ;----------------------------------------
        ; FSR1 = FSR0
        ;----------------------------------------
        lfsr    1, TextData + .256      ; To prevent data loss during assignment
                                        ; Value of indf1 is modified by ISR to 
                                        ; emulate blinking cursor. So we should be
                                        ; sure that fsr1 does not point outside 
                                        ; video memory
        movff   fsr0l, fsr1l
        movff   fsr0h, fsr1h

	;  
	decf	WinCounter, f
	movff	WinCounter, CurWin
	
	return

;********************************************************************
;  08  
;               
;********************************************************************

WORK_ANSI_BS:
	;XPOS = 0 - 
	movf	XPos, w
	btfsc	STATUS, Z
	return
	
	; XPOS
	decf	XPos, f
	
	;  FSR1
        ;----------------------------------------
        ;  FSR0 -   
        ; FSR0 = TextData + (YPos*X_SIZE)*2
        ;----------------------------------------
        lfsr    0, TextData

        movf    YPos, w
        mullw   X_SIZE * 2
        
        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f

        ;----------------------------------------
        ; FSR0 = FSR0 + 2*XPos
        ;----------------------------------------
        rlncf   XPos, w
        
        addwf   FSR0L, f
        btfsc   STATUS, C
        incf    FSR0H, f

	;  
	movf	CurColor, w
	movwf	POSTINC0
	
	;  ' '
	movlw	' '
	movwf	INDF0
	
	movf	POSTDEC0, w
	
        ;----------------------------------------
        ; FSR1 = FSR0
        ;----------------------------------------
        lfsr    1, TextData + .256      ; To prevent data loss during assignment
                                        ; Value of indf1 is modified by ISR to 
                                        ; emulate blinking cursor. So we should be
                                        ; sure that fsr1 does not point outside 
                                        ; video memory
        movff   fsr0l, fsr1l
        movff   fsr0h, fsr1h

	return

;********************************************************************
;  09   
;           
;********************************************************************

WORK_ANSI_HTAB:
	;  
	movf	XPos, w
	andlw	7
	sublw	8
	addwf	XPos, w
	movwf	temp
	
	; 
	movlw	X_SIZE
	cpfslt	temp
	return
	
	;  XPos
	movff	temp, XPos

        ;----------------------------------------
        ;  FSR0 -   
        ; FSR0 = TextData + (YPos*X_SIZE)*2
        ;----------------------------------------
        lfsr    0, TextData

        movf    YPos, w
        mullw   X_SIZE * 2
        
        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f

        ;----------------------------------------
        ; FSR0 = FSR0 + 2*XPos
        ;----------------------------------------
        rlncf   XPos, w
        
        addwf   FSR0L, f
        btfsc   STATUS, C
        incf    FSR0H, f

        ;----------------------------------------
        ; FSR1 = FSR0
        ;----------------------------------------
        lfsr    1, TextData + .256      ; To prevent data loss during assignment
                                        ; Value of indf1 is modified by ISR to 
                                        ; emulate blinking cursor. So we should be
                                        ; sure that fsr1 does not point outside 
                                        ; video memory
        movff   fsr0l, fsr1l
        movff   fsr0h, fsr1h

	;  
	return

;********************************************************************
;  0A   ,  
;  0B   Y     
;********************************************************************

WORK_ANSI_LF:
WORK_ANSI_VTAB:

        ;----------------------------------------
        ;  FSR0 -    XPos
        ; FSR0 = TextData + 2*XPos
        ;----------------------------------------
        lfsr    0, TextData
        rlncf   XPos, w
        addwf   FSR0L, f
        btfsc   STATUS, C
        incf    FSR0H, f

	;----------------------------------------
	;  
	;  -   0
	;----------------------------------------
        incf	YPos, f
        movlw   Y_SIZE
        cpfslt  YPos
        clrf	YPos

        ;----------------------------------------
        ; FSR0 = FSR0 + YPos*X_SIZE*2
        ;----------------------------------------
        movf    YPos, w
        mullw   X_SIZE * 2

        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f
        
        ;----------------------------------------
        ; FSR1 = FSR0
        ;----------------------------------------
        lfsr    1, TextData + .256      ; To prevent data loss during assignment
                                        ; Value of indf1 is modified by ISR to 
                                        ; emulate blinking cursor. So we should be
                                        ; sure that fsr1 does not point outside 
                                        ; video memory
        movff   fsr0l, fsr1l
        movff   fsr0h, fsr1h

	return

;********************************************************************
;  0C     
;         0, 0
; 
;           (3.5 - 4 )
;         :
;      1.  4  
;      2.   SPI_CMD_SEND_CHECK   .
;           = 0x55 -   
;********************************************************************

WORK_ANSI_FF:
        clrf    SSPBUF
        bcf     SSPCON1, WCOL
        call    clear_video_memory
        clrf	WinCounter
        return

;********************************************************************
;  0D      
;       X   0
;********************************************************************

WORK_ANSI_CR:
	;  XPos
	clrf	XPos

        ;----------------------------------------
        ;  FSR0 -   
        ; FSR0 = TextData + (YPos*X_SIZE)*2
        ;----------------------------------------
        lfsr    0, TextData

        movf    YPos, w
        mullw   X_SIZE * 2
        
        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f

        ;----------------------------------------
        ; FSR1 = FSR0
        ;----------------------------------------
        lfsr    1, TextData + .256      ; To prevent data loss during assignment
                                        ; Value of indf1 is modified by ISR to 
                                        ; emulate blinking cursor. So we should be
                                        ; sure that fsr1 does not point outside 
                                        ; video memory
        movff   fsr0l, fsr1l
        movff   fsr0h, fsr1h
	return

;********************************************************************
;  0E     
;            
;            
;          200     20 
;********************************************************************

WORK_STRING_INVERT:
        ;----------------------------------------
        ;  
        ;----------------------------------------
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
        
        ;  - 
        movf	WinCounter, w
        btfsc	STATUS, Z
        return

	;   
	decf	WinCounter, w
	call	get_win_pointer
	
	;  
	lfsr    0, TextData
	
	movf    WinY, w
	addwf	CMD_temp, w
        mullw   X_SIZE * 2

        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f
	
	incf	WinX, w
	mullw	2
	
        movf    PRODL, w
        addwf   FSR0L, f
        movf    PRODH, w
        addwfc  FSR0H, f
        
        ;     calc
        movf	INDF0, w
        movwf	temp

	;
	rlcf	temp, f
	rlcf	calc, f
	rlcf	temp, f
	rlcf	calc, f
	
	rrcf	temp, f
	swapf	temp, f
	
	;
	rlcf	temp, f
	rlcf	calc, f
	rlcf	temp, f
	rlcf	calc, f
	rlcf	temp, f
	rlcf	calc, f
	
	rlcf	temp, f
	rlcf	temp, f
	
	;
	rlcf	temp, f
	rlcf	calc, f
	rlcf	temp, f
	rlcf	calc, f
	rlcf	temp, f
	rlcf	calc, f

        ;     CountY
       	decf	WinWidth, w
       	addlw	-1
       	movwf	CountY
        
        ;  
set_color_loop:
	movff	calc, POSTINC0
	movf	POSTINC0, w
	decfsz	CountY, f
	goto	set_color_loop
        
	return

;********************************************************************
;  0F   X 
;        
;********************************************************************

WORK_SET_WIN_X:

        ;  
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

	; 
	movlw	X_SIZE
	cpfslt	CMD_Temp
	return

        ;   
        movf	WinCounter, w
        call	get_win_pointer
        movff	CMD_Temp, WinX
        call	put_win_pointer
        
	return

;********************************************************************
;  10  Y 
;       
;********************************************************************

WORK_SET_WIN_Y:

        ;  
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

	; 
	movlw	Y_SIZE
	cpfslt	CMD_Temp
	return

        ;   
        movf	WinCounter, w
        call	get_win_pointer
        movff	CMD_Temp, WinY
        call	put_win_pointer
        
	return

;********************************************************************
;  11     
;********************************************************************

WORK_SET_WIN_WIDTH:

        ;  
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

	; 
	movlw	X_SIZE
	cpfslt	CMD_Temp
	return

        ;   
        movf	WinCounter, w
        call	get_win_pointer
        movff	CMD_Temp, WinWidth
        call	put_win_pointer
        
	return

;********************************************************************
;  12     
;********************************************************************

WORK_SET_WIN_HEIGH:

        ;  
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

	; 
	movlw	Y_SIZE
	cpfslt	CMD_Temp
	return

        ;   
        movf	WinCounter, w
        call	get_win_pointer
        movff	CMD_Temp, WinHeigh
        call	put_win_pointer
        
	return

;********************************************************************
;  13    
;********************************************************************

WORK_SET_WIN_COLOR:

        ;  
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow

        ;   
        movff    CMD_Temp, WinColor
        
	return

;********************************************************************
;  14    
;           
;       .     .
;********************************************************************

WORK_SET_CURWIN:
        ;----------------------------------------
        ;  
        ;----------------------------------------
#ifdef MODE_I2C
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
#endif
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
        
        ;  
        incf	WinCounter, w
        cpfslt	CMD_temp
        return
        
        ; 
        movff	CMD_temp, CurWin
        
	return
	
;********************************************************************
;  15      
;********************************************************************

WORK_SEND_X_SIZE

#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

        movlw   X_SIZE
        bra     SPI_SEND

;********************************************************************
;  16      
;********************************************************************

WORK_SEND_Y_SIZE

#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

        movlw   Y_SIZE
        bra     SPI_SEND

;********************************************************************
;  17      
;********************************************************************

WORK_SEND_SYMBOL:

#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

        movf    PREINC1, w
        movf    POSTDEC1, f
        bra     SPI_SEND        
      
;********************************************************************
;  18     X 
;********************************************************************

WORK_SEND_X:

#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

        movf    XPos, w
        bra     SPI_SEND
        
;********************************************************************
;  19     Y 
;********************************************************************

WORK_SEND_Y:

#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

        movf    YPos, w
        bra     SPI_SEND
        
;********************************************************************
;  1A     
;********************************************************************

WORK_SEND_CURSOR:

#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

        ;     
        movf	CursorSize, w
        sublw	0x10
        andlw	0x0F
        bra	SPI_SEND
        
;********************************************************************
;  1B    
;********************************************************************

WORK_SEND_COLOR:

#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

        movf    CurColor, w
        bra     SPI_SEND
        
;********************************************************************
;  1C       
;********************************************************************

WORK_SEND_SYMBOL_COLOR:

#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

        movf    INDF1, w          
        bra     SPI_SEND

;********************************************************************
;  1D     
;********************************************************************

WORK_SEND_WIN:
#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif
	
	movf	WinCounter, w
	bra	SPI_SEND

;********************************************************************
;  1E      / 2
;********************************************************************

WORK_SEND_FREEMEM:

        ;   
        call	get_free_mem
        
	bcf	STATUS, C
	rrcf	FreeMem+1, f
	rrcf	FreeMem, f
        
#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

	movf	FreeMem, w
	bra	SPI_SEND

	return
	
;********************************************************************
;  1F      .
;        0x55.
;        I2C  
;             0x55
;********************************************************************

WORK_SEND_CHECK:

#ifdef MODE_I2C
	;  
        bcf     bByteReceived
        bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
        
        btfss   bByteReceived
        bra     $-2
        btfsc   SSPCON1, SSPOV
        bra     clear_overflow
#endif

        movlw   0x55
        bra     SPI_SEND

;********************************************************************
;	  
;	w -  
;	WinCounter -  
;	WinCounter-1 -   
;	  -  FSR0      
;********************************************************************

get_win_pointer:
	movwf	temp

	;   
	lfsr	0, WinData

get_win_loop:
	;  
	;FSR0 -   
	movff	POSTINC0, WinX
	movff	POSTINC0, WinY
	movff	POSTINC0, WinWidth
	movff	POSTINC0, WinHeigh
	movff	POSTINC0, PrevXPos
	movff	POSTINC0, PrevYPos
	movff	POSTINC0, PrevColor
	movff	POSTINC0, PrevCursor

	;  - 
	movf	temp, w
	bnz	get_next_win
	return
	
get_next_win:
	;  
	decf	temp, f

	;    
	rlncf	WinWidth, w
	mulwf	WinHeigh
	
	movf	PRODL, w
	addwf	FSR0L, f
	movf	PRODH, w
	addwfc	FSR0H, f
	goto	get_win_loop

;********************************************************************
;	   
;	  FSR0 -      
;********************************************************************

put_win_pointer:

	;   
	movf	WinCounter, w
	movwf	temp
	
	;   
	lfsr	0, WinData

put_win_loop:
	;  -  
	movf	temp, w
	bnz	next_win
	
	movff	WinX, POSTINC0
	movff	WinY, POSTINC0
	movff	WinWidth, POSTINC0
	movff	WinHeigh, POSTINC0
	movff	PrevXPos, POSTINC0
	movff	PrevYPos, POSTINC0
	movff	PrevColor, POSTINC0
	movff	PrevCursor, POSTINC0
	return

next_win:
	movf	POSTINC0, w
	movf	POSTINC0, w
	rlncf	POSTINC0, w
	movwf	calc
	movf	POSTINC0, w
	mulwf	calc
	movlw	4
	addwf	PRODL, f
	movlw	0
	addwfc	PRODH, f
	
	movf	PRODL, w
	addwf	FSR0L, f
	movf	PRODH, w
	addwfc	FSR0H, f
	
	decf	temp, f
	goto	put_win_loop

;********************************************************************
;	   
;********************************************************************

get_free_mem:

	;    
	movf	WinCounter, w
	call	get_win_pointer
	
	;     +
	;FreeMem = (0xF5F - FSR0 - 8) / 2
	movlw	0x5F
	movwf	PRODL
	movlw	0x0F
	movwf	PRODH

	movf	FSR0L, w
	subwf	PRODL, f
	movf	FSR0H, w
	subwfb	PRODH, f
	
	movlw	8
	subwf	PRODL, f
	movlw	0
	subwfb	PRODH, f
	
	bcf	STATUS, C
	rrcf	PRODH, f
	rrcf	PRODL, f

	; 
	movff	PRODL, FreeMem
	movff	PRODH, FreeMem+1

	return

;**************************************;
;     SPI              ;
;**************************************;
SPI_SEND:                              ;
        movwf   SSPBUF                 ;
        return                         ;
;--------------------------------------;


;**************************************;
;           ;
;    SPI          ;
;**************************************;
clear_overflow:                        ;
        movf    SSPBUF, w              ;
        bcf     SSPCON1, SSPOV         ;
        return                         ;
;______________________________________;


;********************************************************************
; DEMO 
;         
;********************************************************************

draw_demo_screen:
        lfsr    0, TextData

        movlw   high(DEMO_SCREEN)
        movwf   TBLPTRH
        movlw   low(DEMO_SCREEN)
        movwf   TBLPTRL
        clrf    TBLPTRU

        movlw   Y_SIZE
        movwf   CountY
draw_demo_loop_y:
        movlw   X_SIZE * 2
        movwf   CountX
draw_demo_loop_x:
        tblrd*+
        movff   TABLAT, POSTINC0
        decfsz  CountX, f
        bra     draw_demo_loop_x
        decfsz  CountY, f
        bra     draw_demo_loop_y
        ; 
        movlw   0x10
        iorlw   0x40
        movwf   CursorSize

        return

;********************************************************************
;	 
;********************************************************************
CPU_init:
	;----------------------------------------
	; 
	;----------------------------------------
	
        movlw   0x0F            	;  
        movwf   ADCON1
        
        movlw   0			; 
        movwf   PORTA
        movwf   PORTB
        movwf   PORTC
        movwf	lat_COLOR

        movlw   TRISA_CONST		; 
        movwf   TRISA
        clrf    TRISB
        movlw   TRISC_CONST
        movwf   TRISC
        clrf	TRISD
 
 	bsf	INTCON2, NOT_RBPU	; 
 	
        ;----------------------------------------
        ;  USART
        ;----------------------------------------
        
        movlw   0xB0		;   
        movwf   TXSTA
        movlw   0x00
        movwf   RCSTA
        clrf	SPBRGH
	clrf	SPBRG
	movlw	0x10
	movwf	BAUDCON
	
        ;----------------------------------------
        ;  SPI
        ;----------------------------------------

        movlw   0x00		; CKE = 0, SMP = 0
        movwf   SSPSTAT
        
#ifdef MODE_SPI
        movlw   0x24		; SSPEN = 1, CKP = 0
        movwf   SSPCON1
#endif

#ifdef MODE_I2C
        movlw   0x3E            ; SSPEN = 1, CKP = 1, Slave, 7 bit Addr
        movwf   SSPCON1
        movlw	0x01		; SEN = 1
        movwf	SSPCON2
        movlw	ADDR_I2C	;     I2C
        movwf	SSPADD
#endif

        ;----------------------------------------
        ;  
        ;----------------------------------------

        movlw   T2CON_CONST    	; TMR2 -  VGA 
        movwf   T2CON                
        movlw 	PR2_CONST
        movwf   PR2
        
        movlw   T1CON_CONST	; TMR1 -  1 Hz  FLASH
        movwf   T1CON

        movlw   T0CON_CONST	; TMR0 -  
        movwf   T0CON
        
        ;----------------------------------------
        ;  
        ;----------------------------------------

        bsf     RCON, IPEN       ; TMR2 -  
        BSF     PIE1, TMR2IE
        bsf     IPR1, TMR2IP

        ;----------------------------------------
        ;   
        ;----------------------------------------
                
        clrf    CurPos		;   
        clrf    CurLineL	;   
        clrf    CurLineH
        
        movlw   o'070'		;   -   
        movwf   CurColor
        
        ;----------------------------------------
        ;   
        ;----------------------------------------

        lfsr    1, TextData     ; FSR1 -  

	movlw	low(TextData)   ; FSR2 -  
	movwf	FSR2_temp
	movlw	high(TextData)
	movwf	FSR2_temp+1
	
        movlw   0x40 | 0xE      ;  
        movwf   CursorSize              
     	clrf	flash_counter	;  FLASH
     	clrf	FLAGS		;  
     	clrf	WinCounter	;  
     	clrf	CurWin		;   
     	
        return

;********************************************************************
;	 
;     -     SPACE  
;     -    0,0
;********************************************************************

;*************************************;
;	           ;
;*************************************;
CLEAR_STRING MACRO                    ;
        variable i                    ;
i = 0                                 ;
        WHILE i < (X_SIZE)            ;
            movf     CurColor, w      ;
            movwf    POSTINC0         ;
            movlw    ' '              ;
            movwf    POSTINC0         ;
i += 1                                ;
        ENDW                          ;
    ENDM                              ;
;-------------------------------------;

clear_video_memory:

        lfsr    0, TextData
        movlw   Y_SIZE
        movwf   CountY
        
        ; 
clr_text_loop:
        CLEAR_STRING
        decfsz  CountY, f
        bra     clr_text_loop   

        ;   0,0
        clrf    XPos
        clrf    YPos
        lfsr    1, TextData
       
        return

;********************************************************************
;	  -    
;	     - ; 
;	    (  ) - FSR1
;********************************************************************

WORK_OUT_SYMBOL:
	
	;  
	movf	CurColor, w
	movwf	POSTINC1
	
	; 
	movf	CMD_temp, w
	movwf	POSTINC1
	
	;  
	incf    XPos, f
        movlw   X_SIZE
        cpfseq  XPos
       	return

	;    -  
        clrf    XPos
        incf    YPos,f
        movlw   Y_SIZE
        cpfseq  YPos
        return

	;  -   
        clrf    YPos
        lfsr    1, TextData
        return
	
;********************************************************************
